# coding: utf-8
from os.path import abspath, join, dirname
from math import sqrt


__author__ = '@britodfbr'
__title__ = 'incolumepy.sequencias'
__name__ = __title__.split('.')[-1]
__version__ = open(abspath(join(dirname(__file__), 'version.txt'))).read().strip()
__license__ = None


class Sequencia:

    class Fibonacci:
        def __init__(self):
            self.seq = [1, 1]

        def __next__(self):
            self.seq.append(sum(self.seq))
            return self.seq.pop(0)

        def __iter__(self):
            return Sequencia.Fibonacci()

    class Naturais:
        def __init__(self):
            self.lista = [0]

        def __next__(self):
            self.lista.append(self.lista[0] + 1)
            return self.lista.pop(0)

        def __iter__(self):
            return Sequencia.Naturais()


    class Pares:
        def __init__(self):
            self.lista = [2]

        def __next__(self):
            self.lista.append(self.lista[0] + 2)
            return self.lista.pop(0)

        def __iter__(self):
            return Sequencia.Pares()

        def ispar(self, num):
            return num % 2 == 0

    class Impares:
        def __init__(self):
            self.lista = [1]

        def __next__(self):
            self.lista.append(self.lista[0] + 2)
            return self.lista.pop(0)

        def __iter__(self):
            return Sequencia.Impares()

        def isimpar(self, num):
            return num % 2 == 1

    class Primos:
        '''
        Números primos são os números naturais maiores que 1 e têm apenas dois divisores diferentes: o 1 e ele mesmo.
        '''
        primos = []

        def __init__(self):
            self.primos = [2, 3, 5, 7]
            self.seq = Sequencia.Naturais()

        def __next__(self):
            while 1:
                value = self.seq.__next__()
                if self.isprimo(value):
                    self.primos.append(value)
                    return self.primos[-1]

        def __iter__(self):
            return Sequencia.Primos()

        def isprimo(self, numero):

            if numero in self.primos:
                return True

            if numero <= 1:
                return False

            if Sequencia.Pares().ispar(numero):
                return False

            for i in range(3, numero + 1, 2):

                if (i != numero):
                    if (numero % i == 0):
                        return False
                    if  i > sqrt(numero):
                        continue
                else:
                    self.primos.append(numero)
                    return True



def Main():
    print('\nPrimos')
    a = Sequencia.Primos()
    for i in range(1, 1051):
        print(i, a.__next__())

if __name__ == '__main__':
    Main()
